package board.controller;

import java.util.Enumeration;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import board.service.BoardService;
import board.vo.BoardVo;

import java.lang.reflect.Field;


public class BoardController extends HttpServlet{
	
	private BoardService boardService;
	private String workDir = "/board";	
	
	public void init(ServletConfig conf) throws ServletException {
		super.init(conf);		
		boardService = new BoardService();
	}
	 
	
	protected void service(HttpServletRequest request, HttpServletResponse response){
		String cmd = request.getParameter("cmd");
		try {
			if (cmd.equals("list")) {			
				list(request, response);			
			}else if (cmd.equals("create")) {
				create(request, response);			
		    }else if (cmd.equals("view")) {
				view(request, response);
			}else if (cmd.equals("edit")) {
				edit(request, response);
			}else if (cmd.equals("input")) {
				input(request, response);
			}else if (cmd.equals("modify")) {
				modify(request, response);
			}else if (cmd.equals("delete")) {
				delete(request, response);
			}
		} catch (Exception e) {			
			e.printStackTrace();
		}	
	}
	
	private void foward(HttpServletRequest request, HttpServletResponse response) throws Exception{
		String page = workDir;
		String cmd = request.getParameter("cmd");    
		
		if (cmd.equals("list")) {
			page += "/list.jsp";
	    }else if (cmd.equals("view")) {
	    	page += "/view.jsp";
		}else if (cmd.equals("edit")) {
			page += "/modify.jsp";
		}else if (cmd.equals("create")) {
			page += "/input.jsp";
		}else if (cmd.equals("input")) {
			page = "/board.do?cmd=list";
		}else if (cmd.equals("modify")) {
			page = "/board.do?cmd=list";
		}else if (cmd.equals("delete")) {
			page = "/board.do?cmd=list";
		}
		System.out.println("###### page: "+page);
	//	System.out.println("###### getServletContext(): "+getServletContext());
		
		RequestDispatcher rd = getServletContext().getRequestDispatcher(page);                
  	    rd.forward(request, response);
	}	

	public Object getItems(HttpServletRequest request, Object obj) {
		Class c = obj.getClass();
		Field[] f = c.getFields();
		System.out.println("####### f.length: "+f.length);
		//logging("f.length="+f.length);
		
		Enumeration e1 = request.getParameterNames();
		
		for (Enumeration e = e1 ; e.hasMoreElements() ;) {
			String s = (String)e.nextElement();
			System.out.println("####### key: "+s);
			for (int col = 0; col < f.length; col++) {
				try {
					System.out.println("##### f[col].getName(): "+f[col].getName());					
					if (f[col].getName().equals(s)) {
						System.out.println("request.getParameter(s): "+request.getParameter(s));
						f[col].set(obj,request.getParameter(s));  
					}
				}catch (Exception ex) {
					ex.printStackTrace();
			    }
			}
		}
		
		return obj;
	}
	
	protected void list(HttpServletRequest request, HttpServletResponse response) throws Exception {
		List list = boardService.list();
		request.setAttribute("list", list);	 
	    foward(request, response);
	}
	
	protected void create(HttpServletRequest request, HttpServletResponse response) throws Exception {			 
	    foward(request, response);
	}
	
	protected void input(HttpServletRequest request, HttpServletResponse response) throws Exception {
		BoardVo boadVo = new BoardVo();		
		boardService.input((BoardVo) getItems(request, boadVo));			 
	    foward(request, response);
	}
	
	protected void view(HttpServletRequest request, HttpServletResponse response) throws Exception {
		BoardVo boardVo = boardService.view(request.getParameter("regid"));
		request.setAttribute("boardVo", boardVo);
	    foward(request, response);
	}
	
	protected void edit(HttpServletRequest request, HttpServletResponse response) throws Exception {
		BoardVo boardVo = boardService.view(request.getParameter("regid"));
		request.setAttribute("boardVo", boardVo);
	    foward(request, response);
	}
	
	protected void modify(HttpServletRequest request, HttpServletResponse response) throws Exception {
		BoardVo boardVo = new BoardVo();		
		boardService.modify((BoardVo) getItems(request, boardVo));			 
	    foward(request, response);
	}
	
	protected void delete(HttpServletRequest request, HttpServletResponse response) throws Exception {
		boardService.delete(request.getParameter("regid"));		
	    foward(request, response);
	}
	
}
