/** ̺ BOARD
 REGID                                                 NOT NULL NUMBER(13)
 REGNAME                                               NOT NULL VARCHAR2(40)
 SUBJECT                                               NOT NULL VARCHAR2(100)
 CONTENT                                               NOT NULL VARCHAR2(4000)
 */
package board.dao;


import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import board.vo.BoardVo;

public class BoardDao
{
	private Connection con;
	private Statement stmt;

	public BoardDao()
	{
		try{
			Class.forName("oracle.jdbc.driver.OracleDriver");
		}catch(ClassNotFoundException cnf) {
			System.out.println("DriverLoading Error"+ cnf);
		}
	}

	private void connect()
	{
		String url = "jdbc:oracle:thin:@localhost:1521:ORCL";
		String id = "scott";
		String pass = "tiger";

		try{
			con = DriverManager.getConnection(url, id, pass);
			stmt = con.createStatement();
		}catch(SQLException se) {
			System.out.println("connect() error" + se);
		}
	}

	private void disconnection()
	{
		try{
			stmt.close();
			con.close();
		}catch(SQLException se) {
			System.out.println("disconnection() error" + se);
		}
	}

	public void input(BoardVo board) throws SQLException 
	{
		StringBuffer query = new StringBuffer();
		query.append("insert into board values((select  NVL(max(regid),0)+1 from board),");
		query.append(sql(board.getRegname())).append(",");		
		query.append(sql(board.getSubject())).append(",");		
		query.append(sql(board.getContent())).append(")");

		connect();
		System.out.println(query.toString()); 
		stmt.executeUpdate(query.toString());
		disconnection();
	}
	
	public void modify(BoardVo board) throws SQLException 
	{
		StringBuffer query = new StringBuffer();
		query.append("update board set regname=");
		query.append(sql(board.getRegname())).append(",");
		query.append("subject=");
		query.append(sql(board.getSubject())).append(",");
		query.append("content=");
		query.append(sql(board.getContent())).append(" where regid=");
		query.append(sql(board.getRegid()));
		
		connect();
		System.out.println(query.toString());
		stmt.executeUpdate(query.toString());
		disconnection();
	}
	
	public void delete(String regid) throws SQLException
	{
		String query = "delete from board where regid="+ sql(regid);
		
		connect();
		System.out.println(query.toString());
		stmt.executeUpdate(query.toString());
		disconnection();		
	}
	
	public BoardVo view(String regid) throws SQLException
	{
		String query = "select * from board where regid="+ sql(regid);
		ResultSet result = null;
		BoardVo board = null;

		connect();
		System.out.println(query.toString());
		result = stmt.executeQuery(query);
		if(result.next())
		{
		  
		  board = new BoardVo(result.getString("regid"),result.getString("regname"),result.getString("subject"),
						result.getString("content"));		  
		}
		disconnection();
		return board;
	}

	public List list() throws SQLException
	{
		List list = new ArrayList();
		String query = "select regid, regname, subject from board";
		
		System.out.println(query.toString());
		
		connect();
		ResultSet result = stmt.executeQuery(query);
		while(result.next())
		{
			BoardVo board = new BoardVo(result.getString("regid"),result.getString("regname"),result.getString("subject"),null);
			list.add(board);
		}
		disconnection();
		return list;
	}

	private String sql(String s)
	{
		try {
			return "'" + new String(s.getBytes("8859_1"),"ksc5601") + "'";
		} catch (UnsupportedEncodingException e) {			
			e.printStackTrace();
			return "'" +s + "'";
		}
	}
	
}
